require 'sketchup'
require 'extensions'
module CURIC
  module SectionLite
    PLUGIN            = self
    CRS               = PLUGIN
    PLUGIN_NAMESPACE  = 'Curic'.freeze
    PLUGIN_ID         = 'Section Lite'.freeze
    PLUGIN_NAME       = "#{PLUGIN_NAMESPACE} #{PLUGIN_ID}".freeze
    PLUGIN_VERSION    = '1.0.2'.freeze

    file = __FILE__.dup
    file.force_encoding('UTF-8') if file.respond_to?(:force_encoding)

    FILENAMESPACE = File.basename(file, '.*')
    PATH_ROOT     = File.dirname(file).freeze
    PATH          = File.join(PATH_ROOT, FILENAMESPACE).freeze

    unless file_loaded?(__FILE__)
      ex = SketchupExtension.new(PLUGIN_NAME, "#{FILENAMESPACE}/loader")
      ex.version = PLUGIN_VERSION
      ex.copyright   = 'Curic © 2021–2023'
      ex.creator     = 'Vo Quoc Hai (curic4su@gmail.com)'
      ex.description = 'Create Section Drawing!'
      PLUGIN_EX = ex
      Sketchup.register_extension(ex, true)
    end
  end
end
file_loaded(__FILE__)
