ELEMENT.locale(ELEMENT.lang.en)

// list materials
Vue.component('curic-material', {
  model: {
    prop: 'material',
    event: 'change'
  },
  props: {
    name:{
      type: String
    },
    materials: {
      type: Object,
    },
    material: {
      type:String,
      default: '1'
    },
    size:{
      type:String,
      default: 'mini'
    },
    disabled: {
      type: Boolean,
      default: false
    },
    placeholder:{
      type: String,
      default: 'Seclect a material'
    },
    clearable: Boolean
  },
  data: function() {
    return {
      materialObject(value){
        m = this.materials[value]
        if (m === undefined){ m = {} };
        return m
      }
    }
  },
  template: `
  <span>

      <!-- thumbnail -->
      <template v-if="materialObject(material).is_multimat">

        <div :style="{display: 'inline-block'}">
          <div v-bind:class="['thumbnail', thumbnailClass('Optional1')]">
            <div class="thumbnail-border" title="Optional 1"> 
              <template v-if="materials[material].optional1">
                <img :src="materials[material].optional1.photo">
              </template>
              <template v-else><img class="thumbnail-none"></template>
            </div>
          </div>
          <div v-bind:class="['thumbnail', thumbnailClass('Optional2')]">
            <div class="thumbnail-border" title="Optional 2"> 
              <template v-if="materials[material].optional2">
                <img :src="materials[material].optional2.photo">
              </template>
              <template v-else><img class="thumbnail-none"></template>
             </div>
          </div>
          <div v-bind:class="['thumbnail', thumbnailClass('Optional3')]">
            <div class="thumbnail-border" title="Optional 3"> 
              <template v-if="materials[material].optional3">
                <img :src="materials[material].optional3.photo">
              </template>
              <template v-else><img class="thumbnail-none"></template>
            </div>
          </div>
        </div>
      </template>
      <template v-else-if="materials[material]">
        <div class="thumbnail">
          <div class="thumbnail-border" title="Optionals"> <img :src="materialObject(material).photo"> </div>
        </div>
      </template>

      <div :style="materialsStyle">
        <el-select
          :disabled="disabled"
          :size="size"
          filterable
          :placeholder="placeholder"
          no-data-text="No material"
          :clearable="clearable"
          v-bind:value="material"
          v-on:change="$emit('change', $event)">
  
          <!-- multiple group -->
          <el-option-group
            :key="'multimat'"
            label="Multis">
  
            <el-option
              v-for="(m, key) in materials" v-if="m.is_multimat"
              :key="m.value"
              :label="m.label"
              :value="m.value">
  
              <div class="thumbnail">
                <div class="thumbnail-border"> 
                  <template v-if="m.optional1">
                    <img :src="m.optional1.photo">
                  </template>
                  <template v-else><img class="thumbnail-none"></template>
                </div>
              </div>

              <div class="thumbnail">
                <div class="thumbnail-border"> 
                  <template v-if="m.optional2">
                    <img :src="m.optional2.photo">
                  </template>
                  <template v-else><img class="thumbnail-none"></template>
                </div>
              </div>

              <div class="thumbnail">
                <div class="thumbnail-border"> 
                  <template v-if="m.optional3">
                    <img :src="m.optional3.photo">
                  </template>
                  <template v-else><img class="thumbnail-none"></template>
                </div>
              </div>

              {{ m.label }}
            </el-option>
          </el-option-group>
  
          <!-- single group -->
          <el-option-group
            :key="'single'"
            label="In model">
            <el-option
              v-for="(m, key) in materials" v-if="!m.is_multimat"
              :key="key"
              :label="m.label"
              :value="key">
  
              <div class="thumbnail">
                <div class="thumbnail-border"> <img :src="m.photo"> </div>
              </div>
  
              {{ m.label }}
            </el-option>
          </el-option-group>
  
        </el-select>
      </div>
    </span>
  `,
  methods: {
    thumbnailClass(op){
     if (this.$root.scene && op == this.$root.scene.optional) {
       return 'active'
     }

     return '';
    },
  },
  computed:{
    checkData(){
      console.log(this.material)
      console.log(this.materials)
      console.log(this.materials[this.material])
      console.log(this.materials[this.material].optional1.photo)
      console.log(this.materials[this.material].optional2.photo)
      console.log(this.materials[this.material].optional3.photo)

      return 'AAA'
    },
    // tinh width of materials select with thumnail
    materialsStyle(){
      thumnail = 0
      if (this.materialObject(this.material).is_multimat){
        thumnails = 3*26 - 1
      }else if(this.materialObject(this.material).photo){
        thumnails = 26
      }else{
        thumnails = thumnail == 24 ? 0 : 4
      }

      console.log(thumnails + thumnail + 1)

      style = {
        position: 'absolute',
        display: 'inline-block',
        margin: '0 5px',
        width: 'calc(100% - ' + (thumnails + thumnail + 1) + 'px)'
      }
      return style
    }
  }
})

var app = new Vue({
  el: '#app',
  data: function() {
    return {
      tabPosition: 'left',
      tabValue: 'scene',
      scales: [
        {
          value: 'Custom',
          label: 'Custom'
        },
        {
          value: '1/10',
          label: '1/10'
        },
        {
          value: '1/20',
          label: '1/20'
        },
        {
          value: '1/50',
          label: '1/50'
        },
        {
          value: '1/100',
          label: '1/100'
        },
        {
          value: '1/200',
          label: '1/200'
        },
        {
          value: '1/500',
          label: '1/500'
        },
      ],
      materials: {
        '1':{
          is_multimat: false
        }
      },
      materialObject(value){
        m = this.materials[value]
        if (m === undefined){ m = {} };
        return m
      },
      missingItemMaterials(layer_name){
        item_object = this.su_items.find(l => l.value === layer_name);
        if (item_object && item_object.material){
          return !this.materials[item_object.material]
        }

        return false
      },
      scene: {
        material: 'Cuirc Default',
      },
      su_items:[
        // {
        //   value: 'm_brick',
        //   label: 'm_brick'
        // }
      ],
      selected_item: null,
      item_object: {
        // material: "#[M]-[Curic]Concrete",
      },
      define_item: {},
      dialogNewItemVisible: false,
      more_item_option: false,
      entity:{
        title: "No selection",
        make_fill: false,
      },
      statusBar : {
        drawtime: 0,
        complex_object: 0,
        duplicate_hatch: 0,
      },
      sketchupVersion: 2020,
      showProgress: false,
      progress: 0,
      helpDialog: false,
      notifies: [],
      windowHeight: 500,
      windowWidth: 900,
    }
  },
  watch: {
    progress: function (newValue, oldQuestion) {
      if (newValue == 100) {
        setTimeout(function(){ app.showProgress = false; }, 300)
      } else if (!this.showProgress) {
        this.showProgress = true;
      }
    }
  },
  methods: {
    // toolbar
    newSection(){
      sketchup.new_section();
    },
    removeSection(){
      sketchup.remove_section();
    },

    alignSection(){
      sketchup.align_section();
    },
    fnfSection(){
      sketchup.fnf_section();
    },
    
    // active cut
    changeActiveCut(value){
      sketchup.change_active_cut(value);
    },
    // scale
    sceneScaleChange(value) {
      this.apllyScene()
    },
    // material
    sceneMatChange(value) {
      material = this.materials[value]
      this.apllyScene()
    },
    
    // fit view
    changeFitView(value){
      sketchup.change_fit_view(value);
    },

    apllyScene(value, update){
      sketchup.apply_scene(this.scene, update);
    },

    // Item
    selectedItemChange(value) {
      this.item_object = this.su_items.find(l => l.value === value);
    },

    editItems(){
      sketchup.edit_items(this.itemType);
    },
    apllyItem(){
      sketchup.aplly_item(this.item_object);
    },
    defineNewItem() {
      sketchup.define_item(this.define_item);
      this.dialogNewItemVisible = false;
    },
    home(){
      sketchup.home()
    },
    accept(value){
      var data = {}
      data.plant = this.plant
      data.plant_group = this.plant_group
      sketchup.accept(data);
    },
    sketchup: function(value){
      sketchup.say(value)
    },
    helpTemplate: function(){
      sketchup.helpTemplate()
    },
    helpDocument: function(){
      sketchup.helpDocument()
    },
    helpDocument: function(){
      sketchup.helpCommunity()
    },
    helpContact: function(){
      sketchup.helpContact()
    },
    helpBuyPro: function(){
      sketchup.helpBuyPro()
    },
    buyCoffeePayPal: function(){
      sketchup.buyCoffeePayPal()
    },
    buyCoffeeMomo: function(){
      sketchup.buyCoffeeMomo()
    },
    offNotify(notify, index){
      sketchup.offNotify(notify)
      this.$delete(this.notifies, index)
    }, 
    selectNotify(notify){
      sketchup.selectNotify(notify)
    },
    updateSection(){
      sketchup.updateSection()
    }
  },
  computed:{
    itemType(){
      if(this.scene.order === 'by_solid'){
        return 'Materials' 
      } else if (this.sketchupVersion < 2020) {
        return  'Layers'
      } else {
        return  'Tags'
      }
    },
    disabledMaterialItem(){
      if(this.item_object.use_axes && 
        this.item_object.material_x && this.item_object.material_x != '' &&
        this.item_object.material_y && this.item_object.material_y != '' &&
        this.item_object.material_z && this.item_object.material_z != ''){
          return true
        }
      return false
    },
    showMoreItemOption(){
      return this.more_item_option || this.item_object.use_axes
    },
    linewidthThumbnail(){
      style = {
                height: (!this.item_object.linewidth || this.item_object.linewidth === "None") ? '0' : ((Number(this.item_object.linewidth.replace('mm', '')) < 0.3 ) ? '1px' : this.item_object.linewidth),
                width: '100%',
                background: 'black',
                position: 'absolute',
                bottom: 'calc(11px - '+this.item_object.linewidth+'/2)'
              }
      return style
    },
    linewidthsStyle(){
      style = {
                display: 'inline-block',
                width: 'calc(100%'+(this.item_object.linewidth != 'None' ? ' - 26px': '')+')'
              }
      return style
    }
  },
  mounted: function() {
    this.windowHeight = window.innerHeight;
    this.windowWidth = window.outerWidth;

    sketchup.ready(window.outerWidth, window.outerHeight);

    this.$nextTick(() => {
      window.addEventListener("resize", () => {
        app.windowHeight = window.innerHeight;
        app.windowWidth = window.outerWidth;
      });
    });
  },
})

function updateData(data) {
  app.scene = data;
}

function updateMaterials(materials) {
  app.materials = materials;
}

function updateMaterialsData(multimats, su_materials) {
  app.su_materials = su_materials
  app.multimats = multimats

  cr_materials = []
  for (let i = 0; i < multimats.length; i++) {
    const cr_mat = multimats[i];
    m = {
      label: cr_mat.label,
      value: cr_mat.value,
      optionals: [
        su_materials[cr_mat.optional1].photo,
        su_materials[cr_mat.optional2].photo,
        su_materials[cr_mat.optional3].photo,
      ]
    }
    cr_materials.push(m)
  }
  
  for(var id in materials) {
    materials.push(su_materials[id])
  }

  materials = {
    cr_material: cr_material,
    su_material: su_material
  }
  
  app.materials = materials
}

function updateSectionItems(su_items) {
  selected_item = app.selected_item;
  app.su_items = su_items;
  item_object = app.su_items.find(l => l.value === selected_item);
  if (item_object){
    selectLayer(item_object);
  }else{
    selectLayer(su_items[0]);
  }
}

function selectLayer(item_object, activeLayersTab) {
  app.item_object = item_object;
  app.selected_item = app.item_object ? item_object.value : '';
  if(activeLayersTab) { app.tabValue='su_items' };
}

function defineNewItem(item) {
  app.define_item = item
  app.dialogNewItemVisible = true;
}

function updateStatus(status) {
  app.statusBar = status;
}

function pushNotifies(notifies) {
  app.notifies = notifies
}